<?php 
class ControllerPaymentPoa extends Controller {
	private $error = array(); 
	 
	public function index() { 
		$this->load->language('payment/poa');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('poa', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
				
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_mintotal'] = $this->language->get('entry_mintotal');	
		$this->data['entry_maxtotal'] = $this->language->get('entry_maxtotal');	
		$this->data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_instructions'] = $this->language->get('entry_instructions');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		$this->load->model('localisation/language');
		
		$languages = $this->model_localisation_language->getLanguages();
		
		foreach ($languages as $language) {
			if (isset($this->request->post['poa_instructions_' . $language['language_id']])) {
				$this->data['poa_instructions_' . $language['language_id']] = $this->request->post['poa_instructions_' . $language['language_id']];
			} else {
				$this->data['poa_instructions_' . $language['language_id']] = $this->config->get('poa_instructions_' . $language['language_id']);
			}
			if (isset($this->error['poa_instructions_' . $language['language_id']])) {
				$this->data['error_poa_instructions_' . $language['language_id']] = $this->error['poa_instructions_' . $language['language_id']];
			} else {
				$this->data['error_poa_instructions_' . $language['language_id']] = '';
			}
		}
		
		$this->data['languages'] = $languages;

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/poa', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = $this->url->link('payment/poa', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');	
		
		if (isset($this->request->post['poa_order_status_id'])) {
			$this->data['poa_order_status_id'] = $this->request->post['poa_order_status_id'];
		} else {
			$this->data['poa_order_status_id'] = $this->config->get('poa_order_status_id'); 
		} 
		
		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		$this->data['poa_customer_group_id'] = array();
		
		if (isset($this->request->post['poa_customer_group_id'])) {
			$this->data['poa_customer_group_id'] = $this->request->post['poa_customer_group_id'];
		} elseif ($this->config->get('poa_customer_group_id')){
			$this->data['poa_customer_group_id'] = $this->config->get('poa_customer_group_id');
		} else {
			$this->data['poa_customer_group_id'] = array(); 
		} 
		
		$this->load->model('sale/customer_group');						
		
		$this->data['customer_groups'] = $this->model_sale_customer_group->getCustomerGroups();
		
		if (isset($this->request->post['poa_status'])) {
			$this->data['poa_status'] = $this->request->post['poa_status'];
		} else {
			$this->data['poa_status'] = $this->config->get('poa_status');
		}
		
		if (isset($this->request->post['poa_sort_order'])) {
			$this->data['poa_sort_order'] = $this->request->post['poa_sort_order'];
		} else {
			$this->data['poa_sort_order'] = $this->config->get('poa_sort_order');
		}
		if (isset($this->request->post['poa_mintotal'])) {
			$this->data['poa_mintotal'] = $this->request->post['poa_mintotal'];
		} else {
			$this->data['poa_mintotal'] = $this->config->get('poa_mintotal');
		}
		if (isset($this->request->post['poa_maxtotal'])) {
			$this->data['poa_maxtotal'] = $this->request->post['poa_maxtotal'];
		} else {
			$this->data['poa_maxtotal'] = $this->config->get('poa_maxtotal');
		}

		$this->template = 'payment/poa.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);
				
		$this->response->setOutput($this->render());
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/poa')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
/*
		$this->load->model('localisation/language');

		$languages = $this->model_localisation_language->getLanguages();
		
		foreach ($languages as $language) {
			if (!$this->request->post['poa_instructions_' . $language['language_id']]) {
				$this->error['poa_instructions_' .  $language['language_id']] = $this->language->get('error_instructions');
			}
		}
*/				
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>